=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2011-10-14 10:07:18 +0000
+++ drizzled/item/create.cc	2011-10-17 22:46:16 +0000
@@ -128,7 +128,7 @@
 class Create_native_func : public Create_func
 {
 public:
-  virtual Item* create(Session* session, lex_string_t name, List<Item>* item_list)
+  virtual Item* create(Session* session, str_ref name, List<Item>* item_list)
   {
     if (item_list && has_named_parameters(*item_list))
     {
@@ -145,7 +145,7 @@
     @param item_list The function parameters, none of which are named
     @return An item representing the function call
   */
-  virtual Item* create_native(Session*, lex_string_t name, List<Item>*) = 0;
+  virtual Item* create_native(Session*, str_ref name, List<Item>*) = 0;
 };
 
 
@@ -156,7 +156,7 @@
 class Create_func_arg0 : public Create_func
 {
 public:
-  virtual Item* create(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create(Session *session, str_ref name, List<Item> *item_list);
 
   /**
     Builder method, with no arguments.
@@ -174,7 +174,7 @@
 class Create_func_arg1 : public Create_func
 {
 public:
-  virtual Item* create(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create(Session *session, str_ref name, List<Item> *item_list);
 
   /**
     Builder method, with one argument.
@@ -193,7 +193,7 @@
 class Create_func_arg2 : public Create_func
 {
 public:
-  virtual Item* create(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create(Session *session, str_ref name, List<Item> *item_list);
 
   /**
     Builder method, with two arguments.
@@ -213,7 +213,7 @@
 class Create_func_arg3 : public Create_func
 {
 public:
-  virtual Item* create(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create(Session *session, str_ref name, List<Item> *item_list);
 
   /**
     Builder method, with three arguments.
@@ -246,32 +246,23 @@
   virtual Item* create(Session *session, Item *arg1);
 
   static Create_func_bin s_singleton;
-
-protected:
-  Create_func_bin() {}
 };
 
 class Create_func_concat : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_concat s_singleton;
-
-protected:
-  Create_func_concat() {}
 };
 
 
 class Create_func_concat_ws : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_concat_ws s_singleton;
-
-protected:
-  Create_func_concat_ws() {}
 };
 
 
@@ -286,8 +277,6 @@
   }
 
   static Create_func_conv s_singleton;
-protected:
-  Create_func_conv() {}
 };
 
 Create_func_conv Create_func_conv::s_singleton;
@@ -300,9 +289,6 @@
   virtual Item* create(Session *session, Item *arg1);
 
   static Create_func_cot s_singleton;
-
-protected:
-  Create_func_cot() {}
 };
 
 class Create_func_date_format : public Create_func_arg2
@@ -316,8 +302,6 @@
   }
 
   static Create_func_date_format s_singleton;
-protected:
-  Create_func_date_format() {}
 };
 
 Create_func_date_format Create_func_date_format::s_singleton;
@@ -330,9 +314,6 @@
   virtual Item* create(Session *session, Item *arg1, Item *arg2);
 
   static Create_func_datediff s_singleton;
-
-protected:
-  Create_func_datediff() {}
 };
 
 
@@ -347,9 +328,6 @@
   }
 
   static Create_func_dayname s_singleton;
-
-protected:
-  Create_func_dayname() {}
 };
 
 Create_func_dayname Create_func_dayname::s_singleton;
@@ -365,8 +343,6 @@
   }
 
   static Create_func_dayofmonth s_singleton;
-protected:
-  Create_func_dayofmonth() {}
 };
 
 Create_func_dayofmonth Create_func_dayofmonth::s_singleton;
@@ -382,8 +358,6 @@
   }
 
   static Create_func_dayofweek s_singleton;
-protected:
-  Create_func_dayofweek() {}
 };
 
 Create_func_dayofweek Create_func_dayofweek::s_singleton;
@@ -399,8 +373,6 @@
   }
 
   static Create_func_dayofyear s_singleton;
-protected:
-  Create_func_dayofyear() {}
 };
 
 Create_func_dayofyear Create_func_dayofyear::s_singleton;
@@ -413,9 +385,6 @@
   virtual Item* create(Session *session, Item *arg1, Item *arg2);
 
   static Create_func_decode s_singleton;
-
-protected:
-  Create_func_decode() {}
 };
 
 
@@ -430,8 +399,6 @@
   }
 
   static Create_func_degrees s_singleton;
-protected:
-  Create_func_degrees() {}
 };
 
 Create_func_degrees Create_func_degrees::s_singleton;
@@ -440,24 +407,18 @@
 {
 
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_export_set s_singleton;
-
-protected:
-  Create_func_export_set() {}
 };
 
 
 class Create_func_field : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_field s_singleton;
-
-protected:
-  Create_func_field() {}
 };
 
 
@@ -466,12 +427,12 @@
 public:
   using Create_func_arg2::create;
 
-  virtual Item* create(Session *session, Item *arg1, Item *arg2);
+  virtual Item* create(Session *session, Item *arg1, Item *arg2)
+  {
+    return new (session->mem) Item_func_find_in_set(arg1, arg2);
+  }
 
   static Create_func_find_in_set s_singleton;
-
-protected:
-  Create_func_find_in_set() {}
 };
 
 class Create_func_found_rows : public Create_func_arg0
@@ -479,12 +440,12 @@
 public:
   using Create_func_arg0::create;
 
-  virtual Item* create(Session *session);
+  virtual Item* create(Session *session)
+  {
+    return new (session->mem) Item_func_found_rows();
+  }
 
   static Create_func_found_rows s_singleton;
-
-protected:
-  Create_func_found_rows() {}
 };
 
 
@@ -493,36 +454,30 @@
 public:
   using Create_func_arg1::create;
 
-  virtual Item* create(Session *session, Item *arg1);
+  virtual Item* create(Session *session, Item *arg1)
+  {
+    return new (session->mem) Item_func_from_days(arg1);
+  }
 
   static Create_func_from_days s_singleton;
-
-protected:
-  Create_func_from_days() {}
 };
 
 
 class Create_func_from_unixtime : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_from_unixtime s_singleton;
-
-protected:
-  Create_func_from_unixtime() {}
 };
 
 
 class Create_func_greatest : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_greatest s_singleton;
-
-protected:
-  Create_func_greatest() {}
 };
 
 
@@ -531,12 +486,12 @@
 public:
   using Create_func_arg2::create;
 
-  virtual Item* create(Session *session, Item *arg1, Item *arg2);
+  virtual Item* create(Session *session, Item *arg1, Item *arg2)
+  {
+    return new (session->mem) Item_func_ifnull(arg1, arg2);
+  }
 
   static Create_func_ifnull s_singleton;
-
-protected:
-  Create_func_ifnull() {}
 };
 
 
@@ -545,12 +500,12 @@
 public:
   using Create_func_arg2::create;
 
-  virtual Item* create(Session *session, Item *arg1, Item *arg2);
+  virtual Item* create(Session *session, Item *arg1, Item *arg2)
+  {
+    return new (session->mem) Item_func_locate(arg1, arg2);
+  }
 
   static Create_func_instr s_singleton;
-
-protected:
-  Create_func_instr() {}
 };
 
 
@@ -559,12 +514,12 @@
 public:
   using Create_func_arg1::create;
 
-  virtual Item* create(Session *session, Item *arg1);
+  virtual Item* create(Session *session, Item *arg1)
+  {
+    return new (session->mem) Item_func_isnull(arg1);
+  }
 
   static Create_func_isnull s_singleton;
-
-protected:
-  Create_func_isnull() {}
 };
 
 
@@ -573,24 +528,21 @@
 public:
   using Create_func_arg1::create;
 
-  virtual Item* create(Session *session, Item *arg1);
+  virtual Item* create(Session *session, Item *arg1)
+  {
+    return new (session->mem) Item_func_last_day(arg1);
+  }
 
   static Create_func_last_day s_singleton;
-
-protected:
-  Create_func_last_day() {}
 };
 
 
 class Create_func_last_insert_id : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_last_insert_id s_singleton;
-
-protected:
-  Create_func_last_insert_id() {}
 };
 
 
@@ -599,24 +551,21 @@
 public:
   using Create_func_arg1::create;
 
-  virtual Item* create(Session *session, Item *arg1);
+  virtual Item* create(Session *session, Item *arg1)
+  {
+    return new (session->mem) Item_func_lcase(arg1);
+  }
 
   static Create_func_lcase s_singleton;
-
-protected:
-  Create_func_lcase() {}
 };
 
 
 class Create_func_least : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_least s_singleton;
-
-protected:
-  Create_func_least() {}
 };
 
 class Create_func_load_file : public Create_func_arg1
@@ -624,24 +573,20 @@
 public:
   using Create_func_arg1::create;
 
-  virtual Item* create(Session *session, Item *arg1);
+  virtual Item* create(Session *session, Item *arg1)
+  {
+    return new (session->mem) Item_load_file(*session, arg1);
+  }
 
   static Create_func_load_file s_singleton;
-
-protected:
-  Create_func_load_file() {}
 };
 
-
 class Create_func_locate : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_locate s_singleton;
-
-protected:
-  Create_func_locate() {}
 };
 
 
@@ -656,8 +601,6 @@
   }
 
   static Create_func_lpad s_singleton;
-protected:
-  Create_func_lpad() {}
 };
 
 Create_func_lpad Create_func_lpad::s_singleton;
@@ -673,8 +616,6 @@
   }
 
   static Create_func_ltrim s_singleton;
-protected:
-  Create_func_ltrim() {}
 };
 
 Create_func_ltrim Create_func_ltrim::s_singleton;
@@ -690,8 +631,6 @@
   }
 
   static Create_func_makedate s_singleton;
-protected:
-  Create_func_makedate() {}
 };
 
 Create_func_makedate Create_func_makedate::s_singleton;
@@ -699,12 +638,9 @@
 class Create_func_make_set : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_make_set s_singleton;
-
-protected:
-  Create_func_make_set() {}
 };
 
 
@@ -719,8 +655,6 @@
   }
 
   static Create_func_monthname s_singleton;
-protected:
-  Create_func_monthname() {}
 };
 
 Create_func_monthname Create_func_monthname::s_singleton;
@@ -733,9 +667,6 @@
   virtual Item* create(Session *session, Item *arg1, Item *arg2);
 
   static Create_func_name_const s_singleton;
-
-protected:
-  Create_func_name_const() {}
 };
 
 
@@ -750,8 +681,6 @@
   }
 
   static Create_func_nullif s_singleton;
-protected:
-  Create_func_nullif() {}
 };
 
 Create_func_nullif Create_func_nullif::s_singleton;
@@ -764,9 +693,6 @@
   virtual Item* create(Session *session, Item *arg1);
 
   static Create_func_oct s_singleton;
-
-protected:
-  Create_func_oct() {}
 };
 
 class Create_func_period_add : public Create_func_arg2
@@ -774,12 +700,12 @@
 public:
   using Create_func_arg2::create;
 
-  virtual Item* create(Session *session, Item *arg1, Item *arg2);
+  virtual Item* create(Session *session, Item *arg1, Item *arg2)
+  {
+    return new (session->mem) Item_func_period_add(arg1, arg2);
+  }
 
   static Create_func_period_add s_singleton;
-
-protected:
-  Create_func_period_add() {}
 };
 
 
@@ -788,12 +714,12 @@
 public:
   using Create_func_arg2::create;
 
-  virtual Item* create(Session *session, Item *arg1, Item *arg2);
+  virtual Item* create(Session *session, Item *arg1, Item *arg2)
+  {
+    return new (session->mem) Item_func_period_diff(arg1, arg2);
+  }
 
   static Create_func_period_diff s_singleton;
-
-protected:
-  Create_func_period_diff() {}
 };
 
 
@@ -802,12 +728,12 @@
 public:
   using Create_func_arg0::create;
 
-  virtual Item* create(Session *session);
+  virtual Item* create(Session *session)
+  {
+    return new (session->mem) Item_static_float_func("pi()", M_PI, 6, 8);
+  }
 
   static Create_func_pi s_singleton;
-
-protected:
-  Create_func_pi() {}
 };
 
 class Create_func_radians : public Create_func_arg1
@@ -815,22 +741,21 @@
 public:
   using Create_func_arg1::create;
 
-  virtual Item* create(Session *session, Item *arg1);
+  virtual Item* create(Session *session, Item *arg1)
+  {
+    return new (session->mem) Item_func_units("radians", arg1, M_PI/180, 0.0);
+  }
 
   static Create_func_radians s_singleton;
-protected:
-  Create_func_radians() {}
 };
 
 
 class Create_func_round : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_round s_singleton;
-protected:
-  Create_func_round() {}
 };
 
 
@@ -845,8 +770,6 @@
   }
 
   static Create_func_row_count s_singleton;
-protected:
-  Create_func_row_count() {}
 };
 
 Create_func_row_count Create_func_row_count::s_singleton;
@@ -862,8 +785,6 @@
   }
 
   static Create_func_rpad s_singleton;
-protected:
-  Create_func_rpad() {}
 };
 
 Create_func_rpad Create_func_rpad::s_singleton;
@@ -879,9 +800,6 @@
   }
 
   static Create_func_rtrim s_singleton;
-
-protected:
-  Create_func_rtrim() {}
 };
 
 Create_func_rtrim Create_func_rtrim::s_singleton;
@@ -897,8 +815,6 @@
   }
 
   static Create_func_sign s_singleton;
-protected:
-  Create_func_sign() {}
 };
 
 Create_func_sign Create_func_sign::s_singleton;
@@ -911,8 +827,6 @@
   virtual Item* create(Session *session, Item *arg1);
 
   static Create_func_space s_singleton;
-protected:
-  Create_func_space() {}
 };
 
 class Create_func_strcmp : public Create_func_arg2
@@ -926,8 +840,6 @@
   }
   
   static Create_func_strcmp s_singleton;
-protected:
-  Create_func_strcmp() {}
 };
 
 Create_func_strcmp Create_func_strcmp::s_singleton;
@@ -943,8 +855,6 @@
   }
 
   static Create_func_tan s_singleton;
-protected:
-  Create_func_tan() {}
 };
 
 Create_func_tan Create_func_tan::s_singleton;
@@ -960,8 +870,6 @@
   }
 
   static Create_func_time_format s_singleton;
-protected:
-  Create_func_time_format() {}
 };
 
 Create_func_time_format Create_func_time_format::s_singleton;
@@ -977,8 +885,6 @@
   }
 
   static Create_func_to_days s_singleton;
-protected:
-  Create_func_to_days() {}
 };
 
 Create_func_to_days Create_func_to_days::s_singleton;
@@ -994,8 +900,6 @@
   }
 
   static Create_func_ucase s_singleton;
-protected:
-  Create_func_ucase() {}
 };
 
 Create_func_ucase Create_func_ucase::s_singleton;
@@ -1003,11 +907,9 @@
 class Create_func_unix_timestamp : public Create_native_func
 {
 public:
-  virtual Item* create_native(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item* create_native(Session *session, str_ref name, List<Item> *item_list);
 
   static Create_func_unix_timestamp s_singleton;
-protected:
-  Create_func_unix_timestamp() {}
 };
 
 
@@ -1022,8 +924,6 @@
   }
 
   static Create_func_weekday s_singleton;
-protected:
-  Create_func_weekday() {}
 };
 
 Create_func_weekday Create_func_weekday::s_singleton;
@@ -1036,7 +936,7 @@
 
 Create_udf_func Create_udf_func::s_singleton;
 
-Item* Create_udf_func::create(Session *session, lex_string_t name, List<Item> *item_list)
+Item* Create_udf_func::create(Session *session, str_ref name, List<Item> *item_list)
 {
   return create(session, plugin::Function::get(to_string(name)), item_list);
 }
@@ -1056,42 +956,32 @@
   return func;
 }
 
-Item* Create_func_arg0::create(Session *session, lex_string_t name, List<Item> *item_list)
+Item* Create_func_arg0::create(Session *session, str_ref name, List<Item> *item_list)
 {
-  if (item_list && item_list->size())
-  {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
-    return NULL;
-  }
-  return create(session);
+  if (not item_list || not item_list->size())
+    return create(session);
+  my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
+  return NULL;
 }
 
-Item* Create_func_arg1::create(Session *session, lex_string_t name, List<Item> *item_list)
+Item* Create_func_arg1::create(Session *session, str_ref name, List<Item> *item_list)
 {
-  int arg_count= item_list ? item_list->size() : 0;
-  if (arg_count != 1)
+  if (not item_list || item_list->size() != 1)
   {
     my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
   Item *param_1= item_list->pop();
-
-  if (! param_1->is_autogenerated_name)
-  {
-    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
-    return NULL;
-  }
-
-  return create(session, param_1);
+  if (param_1->is_autogenerated_name)
+    return create(session, param_1);
+  my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
+  return NULL;
 }
 
-
-Item*
-Create_func_arg2::create(Session *session, lex_string_t name, List<Item> *item_list)
+Item* Create_func_arg2::create(Session *session, str_ref name, List<Item> *item_list)
 {
-  int arg_count= item_list ? item_list->size() : 0;
-  if (arg_count != 2)
+  if (not item_list || item_list->size() != 2)
   {
     my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
@@ -1100,22 +990,16 @@
   Item *param_1= item_list->pop();
   Item *param_2= item_list->pop();
 
-  if (   (! param_1->is_autogenerated_name)
-      || (! param_2->is_autogenerated_name))
-  {
-    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
-    return NULL;
-  }
-
+  if (param_1->is_autogenerated_name
+    && param_2->is_autogenerated_name)
   return create(session, param_1, param_2);
+  my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
+  return NULL;
 }
 
-
-Item*
-Create_func_arg3::create(Session *session, lex_string_t name, List<Item> *item_list)
+Item* Create_func_arg3::create(Session *session, str_ref name, List<Item> *item_list)
 {
-  int arg_count= item_list ? item_list->size() : 0;
-  if (arg_count != 3)
+  if (not item_list || item_list->size() != 3)
   {
     my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
@@ -1125,21 +1009,17 @@
   Item *param_2= item_list->pop();
   Item *param_3= item_list->pop();
 
-  if (   (! param_1->is_autogenerated_name)
-      || (! param_2->is_autogenerated_name)
-      || (! param_3->is_autogenerated_name))
-  {
-    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
-    return NULL;
-  }
-
-  return create(session, param_1, param_2, param_3);
+  if (param_1->is_autogenerated_name
+    && param_2->is_autogenerated_name
+    && param_3->is_autogenerated_name)
+    return create(session, param_1, param_2, param_3);
+  my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
+  return NULL;
 }
 
 Create_func_bin Create_func_bin::s_singleton;
 
-Item*
-Create_func_bin::create(Session *session, Item *arg1)
+Item* Create_func_bin::create(Session *session, Item *arg1)
 {
   Item *i10= new (session->mem) Item_int(10, 2);
   Item *i2= new (session->mem) Item_int(2, 1);
@@ -1148,35 +1028,23 @@
 
 Create_func_concat Create_func_concat::s_singleton;
 
-Item*
-Create_func_concat::create_native(Session *session, lex_string_t name, List<Item> *item_list)
+Item* Create_func_concat::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
-  int arg_count= item_list ? item_list->size() : 0;
-  if (arg_count < 1)
-  {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
-    return NULL;
-  }
-
-  return new (session->mem) Item_func_concat(*session, *item_list);
+  if (item_list && item_list->size() >= 1)
+    return new (session->mem) Item_func_concat(*session, *item_list);
+  my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
+  return NULL;
 }
 
-
 Create_func_concat_ws Create_func_concat_ws::s_singleton;
 
-Item*
-Create_func_concat_ws::create_native(Session *session, lex_string_t name,
-                                     List<Item> *item_list)
+Item* Create_func_concat_ws::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
-  int arg_count= item_list ? item_list->size() : 0;
   /* "WS" stands for "With Separator": this function takes 2+ arguments */
-  if (arg_count < 2)
-  {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
-    return NULL;
-  }
-
-  return new (session->mem) Item_func_concat_ws(*session, *item_list);
+  if (item_list && item_list->size() >= 2)
+    return new (session->mem) Item_func_concat_ws(*session, *item_list);
+  my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
+  return NULL;
 }
 
 Create_func_cot Create_func_cot::s_singleton;
@@ -1202,7 +1070,7 @@
 Create_func_export_set Create_func_export_set::s_singleton;
 
 Item*
-Create_func_export_set::create_native(Session *session, lex_string_t name, List<Item> *item_list)
+Create_func_export_set::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
   switch (item_list ? item_list->size() : 0) 
   {
@@ -1230,61 +1098,28 @@
       Item *param_5= item_list->pop();
       return new (session->mem) Item_func_export_set(param_1, param_2, param_3, param_4, param_5);
     }
-  default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
+  my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   return NULL;
 }
 
 
 Create_func_field Create_func_field::s_singleton;
 
-Item*
-Create_func_field::create_native(Session *session, lex_string_t name,
-                                 List<Item> *item_list)
+Item* Create_func_field::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
-  int arg_count= item_list ? item_list->size() : 0;
-  if (arg_count < 2)
-  {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
-    return NULL;
-  }
-
-  return new (session->mem) Item_func_field(*item_list);
+  if (item_list && item_list->size() >= 2)
+    return new (session->mem) Item_func_field(*item_list);
+  my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
+  return NULL;
 }
 
-
 Create_func_find_in_set Create_func_find_in_set::s_singleton;
-
-Item*
-Create_func_find_in_set::create(Session *session, Item *arg1, Item *arg2)
-{
-  return new (session->mem) Item_func_find_in_set(arg1, arg2);
-}
-
 Create_func_found_rows Create_func_found_rows::s_singleton;
-
-Item*
-Create_func_found_rows::create(Session *session)
-{
-  return new (session->mem) Item_func_found_rows();
-}
-
-
 Create_func_from_days Create_func_from_days::s_singleton;
-
-Item*
-Create_func_from_days::create(Session *session, Item *arg1)
-{
-  return new (session->mem) Item_func_from_days(arg1);
-}
-
-
 Create_func_from_unixtime Create_func_from_unixtime::s_singleton;
 
-Item*
-Create_func_from_unixtime::create_native(Session *session, lex_string_t name,
-                                         List<Item> *item_list)
+Item* Create_func_from_unixtime::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
   switch (item_list ? item_list->size() : 0) 
   {
@@ -1300,70 +1135,28 @@
       Item *ut= new (session->mem) Item_func_from_unixtime(param_1);
       return new (session->mem) Item_func_date_format(ut, param_2, 0);
     }
-  default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
+  my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   return NULL;
 }
 
-
 Create_func_greatest Create_func_greatest::s_singleton;
 
-Item*
-Create_func_greatest::create_native(Session *session, lex_string_t name,
-                                    List<Item> *item_list)
+Item* Create_func_greatest::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
-  int arg_count= item_list ? item_list->size() : 0;
-  if (arg_count < 2)
-  {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
-    return NULL;
-  }
-
+  if (item_list && item_list->size() >= 2)
   return new (session->mem) Item_func_max(*item_list);
+  my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
+  return NULL;
 }
 
 Create_func_ifnull Create_func_ifnull::s_singleton;
-
-Item*
-Create_func_ifnull::create(Session *session, Item *arg1, Item *arg2)
-{
-  return new (session->mem) Item_func_ifnull(arg1, arg2);
-}
-
-
 Create_func_instr Create_func_instr::s_singleton;
-
-Item*
-Create_func_instr::create(Session *session, Item *arg1, Item *arg2)
-{
-  return new (session->mem) Item_func_locate(arg1, arg2);
-}
-
-
 Create_func_isnull Create_func_isnull::s_singleton;
-
-Item*
-Create_func_isnull::create(Session *session, Item *arg1)
-{
-  return new (session->mem) Item_func_isnull(arg1);
-}
-
-
 Create_func_last_day Create_func_last_day::s_singleton;
-
-Item*
-Create_func_last_day::create(Session *session, Item *arg1)
-{
-  return new (session->mem) Item_func_last_day(arg1);
-}
-
-
 Create_func_last_insert_id Create_func_last_insert_id::s_singleton;
 
-Item*
-Create_func_last_insert_id::create_native(Session *session, lex_string_t name,
-                                          List<Item> *item_list)
+Item* Create_func_last_insert_id::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
   int arg_count= item_list ? item_list->size() : 0;
   switch (arg_count) {
@@ -1384,19 +1177,9 @@
 
 
 Create_func_lcase Create_func_lcase::s_singleton;
-
-Item*
-Create_func_lcase::create(Session *session, Item *arg1)
-{
-  return new (session->mem) Item_func_lcase(arg1);
-}
-
-
 Create_func_least Create_func_least::s_singleton;
 
-Item*
-Create_func_least::create_native(Session *session, lex_string_t name,
-                                 List<Item> *item_list)
+Item* Create_func_least::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count < 2)
@@ -1409,18 +1192,10 @@
 }
 
 Create_func_load_file Create_func_load_file::s_singleton;
-
-Item*
-Create_func_load_file::create(Session *session, Item *arg1)
-{
-  return new (session->mem) Item_load_file(*session, arg1);
-}
-
-
 Create_func_locate Create_func_locate::s_singleton;
 
 Item*
-Create_func_locate::create_native(Session *session, lex_string_t name,
+Create_func_locate::create_native(Session *session, str_ref name,
                                   List<Item> *item_list)
 {
   int arg_count= item_list ? item_list->size() : 0;
@@ -1450,7 +1225,7 @@
 Create_func_make_set Create_func_make_set::s_singleton;
 
 Item*
-Create_func_make_set::create_native(Session *session_arg, lex_string_t name,
+Create_func_make_set::create_native(Session *session_arg, str_ref name,
                                     List<Item> *item_list)
 {
   int arg_count= item_list ? item_list->size() : 0;
@@ -1475,43 +1250,12 @@
 }
 
 Create_func_period_add Create_func_period_add::s_singleton;
-
-Item*
-Create_func_period_add::create(Session *session, Item *arg1, Item *arg2)
-{
-  return new (session->mem) Item_func_period_add(arg1, arg2);
-}
-
-
 Create_func_period_diff Create_func_period_diff::s_singleton;
-
-Item*
-Create_func_period_diff::create(Session *session, Item *arg1, Item *arg2)
-{
-  return new (session->mem) Item_func_period_diff(arg1, arg2);
-}
-
-
 Create_func_pi Create_func_pi::s_singleton;
-
-Item*
-Create_func_pi::create(Session *session)
-{
-  return new (session->mem) Item_static_float_func("pi()", M_PI, 6, 8);
-}
-
 Create_func_radians Create_func_radians::s_singleton;
-
-Item*
-Create_func_radians::create(Session *session, Item *arg1)
-{
-  return new (session->mem) Item_func_units("radians", arg1,
-                                             M_PI/180, 0.0);
-}
-
 Create_func_round Create_func_round::s_singleton;
 
-Item* Create_func_round::create_native(Session *session, lex_string_t name, List<Item> *item_list)
+Item* Create_func_round::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
   switch (item_list ? item_list->size() : 0) 
   {
@@ -1561,9 +1305,7 @@
 
 Create_func_unix_timestamp Create_func_unix_timestamp::s_singleton;
 
-Item*
-Create_func_unix_timestamp::create_native(Session *session, lex_string_t name,
-                                          List<Item> *item_list)
+Item* Create_func_unix_timestamp::create_native(Session *session, str_ref name, List<Item> *item_list)
 {
   switch (item_list ? item_list->size() : 0) 
   {
@@ -1664,7 +1406,7 @@
     FunctionContainer::getMutableMap()[func->name]= func->builder;
 }
 
-Create_func* find_native_function_builder(lex_string_t name)
+Create_func* find_native_function_builder(str_ref name)
 {
   return find_ptr2(FunctionContainer::getMap(), name.data());
 }

=== modified file 'drizzled/item/create.h'
--- drizzled/item/create.h	2011-07-25 14:24:19 +0000
+++ drizzled/item/create.h	2011-10-17 22:46:16 +0000
@@ -61,7 +61,7 @@
     @param item_list The list of arguments to the function, can be NULL
     @return An item representing the parsed function call, or NULL
   */
-  virtual Item *create(Session *session, lex_string_t name, List<Item> *item_list) = 0;
+  virtual Item *create(Session*, str_ref name, List<Item> *item_list) = 0;
 
 protected:
   virtual ~Create_func() {}
@@ -84,7 +84,7 @@
     @param item_list The list of arguments to the function, can be NULL
     @return An item representing the parsed function call
   */
-  virtual Item *create(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item *create(Session*, str_ref name, List<Item> *item_list);
 
   /**
     The builder create method, for qualified functions.
@@ -95,7 +95,7 @@
     @param item_list The list of arguments to the function, can be NULL
     @return An item representing the parsed function call
   */
-  virtual Item* create(Session*, lex_string_t db, lex_string_t name, bool use_explicit_name, List<Item>*) = 0;
+  virtual Item* create(Session*, str_ref db, str_ref name, bool use_explicit_name, List<Item>*) = 0;
 };
 
 
@@ -104,7 +104,7 @@
   @param name The native function name
   @return The native function builder associated with the name, or NULL
 */
-extern Create_func* find_native_function_builder(lex_string_t name);
+extern Create_func* find_native_function_builder(str_ref name);
 
 
 /**
@@ -122,7 +122,7 @@
 class Create_udf_func : public Create_func
 {
 public:
-  virtual Item *create(Session *session, lex_string_t name, List<Item> *item_list);
+  virtual Item *create(Session*, str_ref name, List<Item> *item_list);
 
   /**
     The builder create method, for User Defined Functions.
@@ -131,7 +131,7 @@
     @param item_list The list of arguments to the function, can be NULL
     @return An item representing the parsed function call
   */
-  Item *create(Session *session, const plugin::Function *fct, List<Item> *item_list);
+  Item *create(Session*, const plugin::Function *fct, List<Item> *item_list);
 
   /** Singleton. */
   static Create_udf_func s_singleton;
@@ -142,7 +142,7 @@
 };
 
 Item*
-create_func_char_cast(Session *session, Item *a, int len, const charset_info_st * const cs);
+create_func_char_cast(Session*, Item *a, int len, const charset_info_st * const cs);
 
 /**
   Builder for cast expressions.

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2011-10-06 18:18:31 +0000
+++ drizzled/show.cc	2011-10-17 22:46:16 +0000
@@ -266,7 +266,7 @@
   return true;
 }
 
-bool buildEngineStatus(Session *session, lex_string_t)
+bool buildEngineStatus(Session *session, str_ref)
 {
   session->lex().sql_command= SQLCOM_SELECT;
   drizzled::statement::Show *select= new statement::Show(session);
@@ -479,7 +479,7 @@
   return true;
 }
 
-bool buildCreateSchema(Session *session, lex_string_t &ident)
+bool buildCreateSchema(Session *session, str_ref ident)
 {
   session->lex().sql_command= SQLCOM_SELECT;
   drizzled::statement::Show *select= new statement::Show(session);

=== modified file 'drizzled/show.h'
--- drizzled/show.h	2011-07-25 14:24:19 +0000
+++ drizzled/show.h	2011-10-17 22:46:16 +0000
@@ -27,40 +27,37 @@
 #pragma once
 
 #include <drizzled/enum.h>
-#include <drizzled/lex_string.h>
-
+#include <drizzled/util/data_ref.h>
 #include <drizzled/visibility.h>
 
 namespace drizzled {
 
-int wild_case_compare(const charset_info_st * const cs, 
-                      const char *str,const char *wildstr);
+int wild_case_compare(const charset_info_st*, const char *str, const char *wildstr);
 
 DRIZZLED_API int get_quote_char_for_identifier();
 
 namespace show {
 
-bool buildColumns(Session *session, const char *schema_ident, Table_ident *table_ident);
-bool buildCreateSchema(Session *session, lex_string_t &ident);
-bool buildCreateTable(Session *session, Table_ident *ident);
-bool buildDescribe(Session *session, Table_ident *ident);
-bool buildIndex(Session *session, const char *schema_ident, Table_ident *table_ident);
-bool buildProcesslist(Session *session);
+bool buildColumns(Session*, const char *schema_ident, Table_ident *table_ident);
+bool buildCreateSchema(Session*, str_ref ident);
+bool buildCreateTable(Session*, Table_ident *ident);
+bool buildDescribe(Session*, Table_ident *ident);
+bool buildIndex(Session*, const char *schema_ident, Table_ident *table_ident);
+bool buildProcesslist(Session*);
 bool buildSchemas(Session*);
-bool buildStatus(Session *session, const drizzled::sql_var_t is_global);
-bool buildEngineStatus(Session *session, lex_string_t);
-bool buildTableStatus(Session *session, const char *ident);
-bool buildTables(Session *session, const char *ident);
-bool buildTemporaryTables(Session *session);
-bool buildVariables(Session *session, const drizzled::sql_var_t is_global);
-
-void buildErrors(Session *session);
-void buildWarnings(Session *session);
-
-void buildSelectWarning(Session *session);
-void buildSelectError(Session *session);
+bool buildStatus(Session*, const drizzled::sql_var_t is_global);
+bool buildEngineStatus(Session*, str_ref);
+bool buildTableStatus(Session*, const char *ident);
+bool buildTables(Session*, const char *ident);
+bool buildTemporaryTables(Session*);
+bool buildVariables(Session*, const drizzled::sql_var_t is_global);
+
+void buildErrors(Session*);
+void buildWarnings(Session*);
+
+void buildSelectWarning(Session*);
+void buildSelectError(Session*);
 
 } // namespace show
 
 } /* namespace drizzled */
-

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-10-17 21:19:03 +0000
+++ drizzled/sql_yacc.yy	2011-10-17 22:46:16 +0000
@@ -49,6 +49,7 @@
 #include <drizzled/var.h>
 #include <drizzled/system_variables.h>
 #include <drizzled/lex_input_stream.h>
+#include <drizzled/show.h>
 
 int yylex(union ParserType *yylval, drizzled::Session *session);
 

=== modified file 'drizzled/statement.h'
--- drizzled/statement.h	2011-03-28 23:48:44 +0000
+++ drizzled/statement.h	2011-10-17 22:46:16 +0000
@@ -24,7 +24,6 @@
 #include <drizzled/error.h>
 #include <drizzled/sql_parse.h>
 #include <drizzled/sql_base.h>
-#include <drizzled/show.h>
 
 namespace drizzled {
 namespace statement {

